@echo off

rem  Here you can configure the compression tool and the version number that will
rem  be used in the archive filename.
set VERSION=0.13_win
set PACKER_DIR=c:\program files\7-zip
set PACKER="%PACKER_DIR%\7z.exe"
set ARCHIVE_OPT=a -tzip -mx9
set ARCHIVE_SUFFIX=zip
set DISTRI_DIR=_distri

rem  Check if packer is available (see above)
if not exist %PACKER% (
  set MSG="Packer not found! (PACKER='%PACKER%')"
  goto :PRINT_ERROR_AND_EXIT
)

rem  Check if VC is available 
if exist "%VS100COMNTOOLS%\..\IDE\devenv.exe" (
  set VC="%VS100COMNTOOLS%\..\IDE\devenv.exe"
) else if exist "%VS100COMNTOOLS%\..\IDE\vcexpress.exe" (
  set VC="%VS100COMNTOOLS%\..\IDE\vcexpress.exe"
) else (
  set MSG="No valid VC found! (VS90COMNTOOLS='%VS100COMNTOOLS%')"
  goto :PRINT_ERROR_AND_EXIT
)

rem  Add packer directory to PATH
set PATH=%PATH%;%PACKER_DIR%

rem  Recreate distribution directory  and set it up with all the resource files
rem  of OctaneExport
rmdir /s /q %DISTRI_DIR%
mkdir %DISTRI_DIR%
xcopy /q /s /i ..\..\res %DISTRI_DIR%\OctaneExport\res

rem  Build all the different configurations

REM set CONFIG=R9.6_Debug
REM set CONFIG_ZIP=r9.6_debug
REM call :BUILD_AND_COMPRESS
set CONFIG=C4DR9.6_Release
set CONFIG_ZIP=r9.6
call :BUILD_AND_COMPRESS

REM set CONFIG=C4DR10.1_Debug
REM set CONFIG_ZIP=r10.1_debug
REM call :BUILD_AND_COMPRESS
set CONFIG=C4DR10.1_Release
set CONFIG_ZIP=r10.1
call :BUILD_AND_COMPRESS

REM set CONFIG=C4DR10.5_Debug
REM set CONFIG_ZIP=r10.5_debug
REM call :BUILD_AND_COMPRESS
REM set CONFIG=C4DR10.5_Release
REM set CONFIG_ZIP=r10.5
REM call :BUILD_AND_COMPRESS

REM set CONFIG=C4DR11.0_Debug
REM set CONFIG_ZIP=r11_debug
REM call :BUILD_AND_COMPRESS
REM set CONFIG=C4DR11.0_Release
REM set CONFIG_ZIP=r11
REM call :BUILD_AND_COMPRESS

REM set CONFIG=C4DR11.5_Debug
REM set CONFIG_ZIP=r11_debug
REM call :BUILD_AND_COMPRESS
set CONFIG=C4DR11.5_Release
set CONFIG_ZIP=r11.5
call :BUILD_AND_COMPRESS

REM set CONFIG=C4DR12.0_Debug
REM set CONFIG_ZIP=r12_debug
REM call :BUILD_AND_COMPRESS
set CONFIG=C4DR12.0_Release
set CONFIG_ZIP=r12
call :BUILD_AND_COMPRESS

REM set CONFIG=C4DR13.0_Debug
REM set CONFIG_ZIP=r13_debug
REM call :BUILD_AND_COMPRESS
REM set CONFIG=C4DR13.0_Release
REM set CONFIG_ZIP=r13
REM call :BUILD_AND_COMPRESS

REM set CONFIG=C4DR14.0_Debug
REM set CONFIG_ZIP=r14_debug
REM call :BUILD_AND_COMPRESS
REM set CONFIG=C4DR14.0_Release
REM set CONFIG_ZIP=r14
REM call :BUILD_AND_COMPRESS

rem  Remove plugin files
rmdir /s /q %DISTRI_DIR%\OctaneExport

rem  Stop
goto :EOF


rem  This "function" builds one configuration of OctaneExport and creates an archive of it
:BUILD_AND_COMPRESS
%VC% ..\..\OctaneExport.sln /rebuild "%CONFIG%|Win32"
if not exist ..\..\bin\%CONFIG%\OctaneExport.cdl (
  set MSG="Build of configuration '%CONFIG% - Win32' failed!"
  goto :PRINT_ERROR_AND_EXIT
)
%VC% ..\..\OctaneExport.sln /rebuild "%CONFIG%|x64"
if not exist ..\..\bin\%CONFIG%\OctaneExport.cdl64 (
  set MSG="Build of configuration '%CONFIG% - x64' failed!"
  goto :PRINT_ERROR_AND_EXIT
)
xcopy /q /y ..\..\bin\%CONFIG%\OctaneExport.cdl   %DISTRI_DIR%\OctaneExport\
xcopy /q /y ..\..\bin\%CONFIG%\OctaneExport.cdl64 %DISTRI_DIR%\OctaneExport\
cd %DISTRI_DIR%
%PACKER% %ARCHIVE_OPT% OctaneExport_%VERSION%_%CONFIG_ZIP%.%ARCHIVE_SUFFIX% OctaneExport
cd ..
goto :EOF


rem  Prints an error message and exits the batch file
:PRINT_ERROR_AND_EXIT
echo %MSG%
pause
exit /b 1
