#! /bin/bash


VERSION="0.13_mac"
DISTRI_DIR="_distri"


function BuildAndPack {
  xcodebuild clean build -configuration "$2" -sdk "$1"
  if [ "$?" != "0" ]; then exit 1; fi 
  cp "$2/OctaneExport.dylib" "$DISTRI_DIR/OctaneExport"
  CUR_DIR=`pwd`
  cd "$DISTRI_DIR"
  zip -9 -r "OctaneExport_${VERSION}_${3}.zip" OctaneExport
  cd "$CUR_DIR"
}


rm -fR "$DISTRI_DIR"
mkdir -p "$DISTRI_DIR/OctaneExport"
cp -R ../../res "$DISTRI_DIR/OctaneExport"


# BuildAndPack "macosx10.4" "R9.6_Debug"    "r9.6_debug"
BuildAndPack "macosx10.4" "R9.6_Release"  "r9.6"
# BuildAndPack "macosx10.4" "R10.1_Debug"   "r10.1_debug"
BuildAndPack "macosx10.4" "R10.1_Release" "r10.1"
# BuildAndPack "macosx10.5" "R10.5_Debug"   "r10.5_debug"
# BuildAndPack "macosx10.5" "R10.5_Release" "r10.5"
# BuildAndPack "macosx10.5" "R11.0_Debug"   "r11_debug"
BuildAndPack "macosx10.5" "R11.0_Release" "r11"
# BuildAndPack "macosx10.5" "R11.5_Debug"   "r11.5_debug"
BuildAndPack "macosx10.5" "R11.5_Release" "r11.5"
# BuildAndPack "macosx10.5" "R12.0_Debug"   "r12_debug"
BuildAndPack "macosx10.5" "R12.0_Release" "r12"


rm -fR "$DISTRI_DIR/OctaneExport"
