#ifndef _BUFFEREDTEXTFILE_H_
#define _BUFFEREDTEXTFILE_H_  1



#include <c4d.h>

#include "common.h"



class BufferedTextFile
{
public:

    BufferedTextFile();
    BufferedTextFile(const Filename& filePath,
                     FILEOPEN        mode,
                     FILEDIALOG      errDialog);
    ~BufferedTextFile();

    inline bool isOpen() const;

    bool open(const Filename& path,
              FILEOPEN        mode,
              FILEDIALOG      errDialog);
    void close();

    bool write(LONG v);
    bool write(ULONG v);
    bool write(SReal v);
    bool write(LReal v);
    bool write(const Vector& v);
    bool write(const String& s);
    bool write(char c);
    bool write(const char* s);

    bool flush();


private:

    BaseFile* mFile;
    CHAR*     mBuffer;
    ULONG     mBufferSize;
    ULONG     mBufferCapacity;
};



inline bool BufferedTextFile::isOpen() const
{
  return (mFile != 0);
}



#endif  // #ifndef _BUFFEREDTEXTFILE_H_
