#include "common.h"
#include "entry_dialog.h"



EntryDialog::EntryDialog()
:
    mClosedWithOk(false),
    mButtons(BTN_OK)
{}


EntryDialog::ReturnType EntryDialog::openModal(const String&    title,
                                               const String&    message,
                                               const String&    prepopulatedValue,
                                               const ButtonType buttons)
{
    mTitle   = title;
    mMessage = message;
    mValue   = prepopulatedValue;
    mButtons = buttons;
    
    mClosedWithOk = false;
    if (!Open(DLG_TYPE_MODAL_RESIZEABLE, 0) || !mClosedWithOk)
    {
        return RET_CANCEL;
    }
    return RET_OK;
}


Bool EntryDialog::CreateLayout()
{
    GroupBegin(IDG_MAIN, BFH_SCALEFIT, 1, 3, String(), 0);
    {
        GroupSpace(8, 8);
        GroupBorderSpace(8, 8, 8, 8);
        AddStaticText(IDS_MESSAGE_TEXT, BFH_SCALE|BFH_LEFT, 0, 0,
                      mMessage, BORDER_NONE);
        AddEditText(IDD_ENTRY_FIELD, BFH_SCALEFIT, 0, 0);
        GroupBegin(0, BFH_CENTER, 2, 1, String(), 0);
        {
            AddButton(IDB_OK,     0, 60, 0, "OK");
            AddButton(IDB_CANCEL, 0, 60, 0, "Cancel");
        }
        GroupEnd();
    } 
    GroupEnd();
    return TRUE;
}


Bool EntryDialog::Command(LONG                 id,
                          const BaseContainer& msg)
{
    switch (id)
    {
        case IDB_OK:
            GetString(IDD_ENTRY_FIELD, mValue);
            mClosedWithOk = true;
            Close();
            break;
        case IDB_CANCEL:
            mClosedWithOk = false;
            Close();
            break;
    }
    return TRUE;
}
