#ifndef ENTRY_DIALOG_H
#define ENTRY_DIALOG_H 1



#include <c4d.h>



class EntryDialog : private GeDialog
{
public:

    enum ButtonType
    {
        BTN_OK = 0,
        BTN_OK_CANCEL
    };

    enum ReturnType
    {
        RET_OK,
        RET_CANCEL
    };

    enum
    {
        IDG_MAIN = 1000,
        IDS_MESSAGE_TEXT,
        IDD_ENTRY_FIELD,
        IDB_OK,
        IDB_CANCEL
    };


    EntryDialog();

    ReturnType openModal(const String&    title,
                         const String&    message,
                         const String&    prepopulatedValue,
                         const ButtonType buttons);

    inline const String& lastValue() const;

    // --- Implementation(s) for GeModalDialog ---

    virtual Bool CreateLayout();

    virtual Bool Command(LONG                 id,
                         const BaseContainer& msg);


private:

    bool       mClosedWithOk;
    String     mTitle;
    String     mMessage;
    ButtonType mButtons;
    String     mValue;
};


inline const String& EntryDialog::lastValue() const
{
    return mValue;
}



#endif  // #ifndef ENTRY_DIALOG_H
