#ifndef _OE_OBJ_MATERIAL_
#define _OE_OBJ_MATERIAL_  1



#include <c4d.h>

#include "bufferedtextfile.h"



struct OEOBJColorChannel
{
    bool     mEnabled;
    Vector   mColor;
    Filename mFilename;

    OEOBJColorChannel();
    bool write(BufferedTextFile& file,
               const char*       name) const;
};


struct OEOBJBumpChannel
{
    bool     mEnabled;
    Filename mFilename;
    Real     mStrength;


    OEOBJBumpChannel();
    bool write(BufferedTextFile& file,
               const char*       name) const;
};


struct OEOBJFloatChannel
{
    Real     mValue;
    Filename mFilename;

    OEOBJFloatChannel();
    bool write(BufferedTextFile& file,
               const char*       name) const;
};


struct OEOBJMaterial
{
    OEOBJColorChannel mKa;
    OEOBJColorChannel mKd;
    OEOBJColorChannel mKs;
    OEOBJFloatChannel mNs;
    OEOBJFloatChannel mD;
    OEOBJBumpChannel  mBump;

    Real              mNi;
    Vector            mTf;
    bool              mHasTransparency;


    OEOBJMaterial();
    bool write(BufferedTextFile& file,
               const String&     name) const;
};



#endif  // #ifndef _OE_OBJ_MATERIAL_