#include "c4d_symbols.h"
#include "common.h"
#include "oe_converter.h"
#include "oe_export_dlg.h"
#include "oe_render.h"
#include "utilities.h"



/*****************************************************************************
 * Implementation of public member functions of class OERender.
 *****************************************************************************/

/// Registers this plugin instance in CINEMA 4D.
///
/// @return
///   true if successfull, otherwise false.
bool OERender::registerPlugin()
{
  return RegisterCommandPlugin(PID_OE_RENDER,
                               GeLoadString(IDS_OE_RENDER),
                               0,
                               AutoBitmap("icon_oe_export_render.tif"),
                               GeLoadString(IDS_OE_RENDER_DESCR),
                               this);
}


///
Bool OERender::Execute(BaseDocument* document)
{
  if (!document) { ERRLOG_RETURN_VALUE(FALSE, "OERender::Execute(): Invalid document pointer passed in"); }
  OEConverter converter;
  OEExportDlg::readExportSettings(*document, converter);
  if (converter.exportToObj(false)) {
    converter.launchOctane(false, 0);
  }

  return TRUE;
}
