#ifndef _OE_SCENEHOOK_H_
#define _OE_SCENEHOOK_H_ 1



#include <c4d.h>



#define PID_OE_SCENEHOOK   1025240



/***************************************************************************//*!
*//****************************************************************************/
class OESceneHook : public SceneHookData
{
public:

    BaseContainer mExportDlgSettings;


    static NodeData* alloc();

    static bool registerPlugin();

    /// Returns the Octane exporter scene hook of a document.
    static OESceneHook* get(
        BaseDocument &document);

    virtual Bool Read(
        GeListNode *node,
        HyperFile  *hf,
        LONG       level);

    virtual Bool Write(
        GeListNode *node,
        HyperFile  *hf);

    virtual Bool CopyTo(
        NodeData   *dest,
        GeListNode *snode,
        GeListNode *dnode,
        COPYFLAGS  flags,
        AliasTrans *trn);


private:

    inline void copyExportSetting(
        BaseContainer &destContainer,
        const LONG    id);

    void convertRenderTargetSettings();
};



#endif  // #ifndef _OE_SCENEHOOK_H_
