#ifndef _OE_UVW_TEXMAP_H_
#define _OE_UVW_TEXMAP_H_  1



#include <c4d.h>

#include "autoref.h"
#include "common.h"



/***************************************************************************//*!
*//****************************************************************************/
class OEUVWTexMap
{
public:

  OEUVWTexMap(TextureTag*   textureTag,
              const Matrix& globalMatrix);
  ~OEUVWTexMap();

  void init(PolygonObject& object,
            const Matrix&  globalMatrix,
            BaseView*      view);
  void finish();

  void getUVWs(ULONG  polyIx,
               Vector uvws[4]);


private:

  TextureTag* mTextureTag;
  Matrix      mTexGlobMat;
  bool        mUVWTagOwner;
  UVWTag*     mUVWTag;
  UVWHandle   mTagData;
  Vector      mScale;
  Vector      mShift;
};

typedef AutoRef<OEUVWTexMap>  OEUVWTexMapH;



#endif  // #ifndef _OE_UVW_TEXMAP_H_
