#include <windows.h>
#include "utilities.h"



HANDLE _runProgramInternal(const WCHAR* appName,
                           WCHAR*       cmdLine,
                           const WCHAR* workingDir,
                           bool         runInBackground)
{
  STARTUPINFOW        startInfo;
  PROCESS_INFORMATION procInfo;

  ZeroMemory(&startInfo, sizeof(startInfo));
  startInfo.cb          = sizeof(startInfo);
  if (runInBackground) {
    startInfo.dwFlags     = STARTF_USESHOWWINDOW;
    startInfo.wShowWindow = SW_SHOWNOACTIVATE;
    LockSetForegroundWindow(LSFW_LOCK);
  }
  ZeroMemory(&procInfo, sizeof(procInfo));

  if (CreateProcessW(appName,
                     cmdLine,
                     NULL,
                     NULL,
                     false,
                     0,
                     NULL,
                     workingDir,
                     &startInfo,
                     &procInfo))
  {
    return procInfo.hProcess;
  } else {
    return NULL;
  }
}


bool _isValidInternal(const HANDLE& process)
{
  return (process != NULL);
}


bool _programIsRunningInternal(const HANDLE& process)
{
  DWORD exitCode;
  if (!process || !GetExitCodeProcess(process, &exitCode)) {
    return false;
  }
  return (exitCode == STILL_ACTIVE);
}


void _stopProgramInternal(const HANDLE& process)
{
  TerminateProcess(process, EXIT_FAILURE);
}
